POJ-3126-Prime Path(BFS)

来源:互联网 发布:mac retina 13寸壁纸 编辑:程序博客网 时间:2024/05/18 14:44

F - Prime Path
Time Limit:1000MS Memory Limit:65536KB 64bit IO Format:%I64d & %I64u
Submit

Status

Practice

POJ 3126
Appoint description:
Description
The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on… Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input
3
1033 8179
1373 8017
1033 1033
Sample Output
6
7
0

题意:给出两个四位数的素数A和B,每次可以变换一个数字,变换的每个数字都要是素数,从A变换到B需要多少步。
思路:由于需要判断素数,先筛法打个表,然后广搜枚举每一位,注意枚举时出现过的数就不要让它入队,这是很重要的剪枝。

代码(0ms)

#include<stdio.h>#include<iostream>#include<algorithm>#include<queue>#include<math.h>#include<string.h>#include<string>using namespace std;const int maxn=10005;int is_prim[maxn];struct node{    int num;    int steap;};void Prim_num(){    memset(is_prim,1,sizeof(is_prim));    is_prim[1]=0;    for(int i=2; i<sqrt(maxn); i++)        if(is_prim[i])            for(int j=2; i*j<=maxn; j++)                is_prim[i*j]=0;}void BFS(int star_num,int end_num){    node star;    queue<node>q;    star.num=star_num;    star.steap=0;    q.push(star);    is_prim[star.num]=0;    while(!q.empty())    {        star=q.front();        q.pop();        if(star.num==end_num)        {            printf("%d\n",star.steap);            return;        }        int num_1=star.num%10;//个位        int num_2=star.num%100/10;//十位        int num_3=star.num%1000/100;//百位        int num_4=star.num/1000;//千位        node end;        for(int i=1; i<=9; i=i+2) //枚举个位        {            end.num=num_4*1000+num_3*100+num_2*10+i;            if(end.num!=star.num&&is_prim[end.num])            {                end.steap=star.steap;                end.steap++;                is_prim[end.num]=0;                if(end.num==end_num)                {                    printf("%d\n",end.steap);                    return;                }                q.push(end);            }        }        for(int i=0; i<=9; i++) //枚举十位        {            end.num=num_4*1000+num_3*100+i*10+num_1;            if(end.num!=star.num&&is_prim[end.num])            {                end.steap=star.steap;                end.steap++;                is_prim[end.num]=0;                if(end.num==end_num)                {                    printf("%d\n",end.steap);                    return;                }                q.push(end);            }        }        for(int i=0; i<=9; i++) //枚举百位        {            end.num=num_4*1000+i*100+num_2*10+num_1;            if(end.num!=star.num&&is_prim[end.num])            {                end.steap=star.steap;                end.steap++;                is_prim[end.num]=0;                if(end.num==end_num)                {                    printf("%d\n",end.steap);                    return;                }                q.push(end);            }        }        for(int i=1; i<=9; i++) //枚举千位        {            end.num=i*1000+num_3*100+num_2*10+num_1;            if(end.num!=star.num&&is_prim[end.num])            {                end.steap=star.steap;                end.steap++;                is_prim[end.num]=0;                if(end.num==end_num)                {                    printf("%d\n",end.steap);                    return;                }                q.push(end);            }        }    }    printf("Impossible\n");}int main(){    int T;    scanf("%d",&T);    while(T--)    {        Prim_num();        int star_num,end_num;        scanf("%d%d",&star_num,&end_num);        BFS(star_num,end_num);    }    return 0;}
0 0